N=100;      	% signal length
K=10;        	% level of the noise (make experiments changing K!)
M=11; 		% filter window length (odd! make experiments!)

x0=[zeros(N/2-10,1); 100*ones(20,1); zeros(N/2-10,1)];  % impulse signal
yv=x0+K*randn(N,1);                                     % noisy signal
yvfilt=zeros(1,N); M1=(M-1)/2;
for k=M-1:N-M, yvfilt(k)=median(yv(k-M1:k+M1)); end;                                         % computing LS estimate
figure(2), plot([1:N],yv,'b',[1:N],yvfilt,'r'); grid;







